library mydll;

{$mode objfpc}{$H+}

uses
  md5, sysutils;

{ Summary:
    Create a MD5 hash from a string and return the result.

  Authors:
    Alexandre Leclerc
    Lars (L505)
}

function MakeMD5Hash_Alex(aValue: pchar): pchar; stdcall;
var
  s: string;
  size: Integer;
begin
  s := MD5Print(MD5String(aValue));
  size := Length(s) + 1;

  Result := nil;
  GetMem(Result,size);
//  Result := StrAlloc(size); //Use strings;

  Move(Pointer(s)^, Result^, size);
end;


{ return the hash result based on input aValue }
function MakeMD5Hash_L505(aValue: pchar; MD5_Rslt: pchar): longint;  stdcall;
var
  mystr: string; // local variable, dangerous to point to unless copied
  temp: pchar;   // temporary pchar
  size: Integer;
begin

  mystr:= MD5Print(MD5String(aValue));
  size:= Length(mystr) + 1;

  // return the size of the result
  Result:= size;
  temp:= pchar(mystr);  // careful, temp is pointing to a local variable mystr!

          {out}     {in}
  StrCopy(MD5_Rslt, temp);

// temp is now copied to 'rslt' parameter, and must be, otherwise the calling
// program can give access violations

end;
{ Warning: mystr is freed at the end of this function.

  BAD CODE:

   MD5_Rslt:= pchar(mystr); // MD5_rslt is pointing to a local variable, mystr,
                            // already freed when we try to use it in the EXE!
}


{ return the size of the hash specifically }
function GetMD5HashSize_L505(aValue: pchar): longint;  stdcall;
var
  mystr: string;
  size: Integer;
begin
  mystr:= MD5Print(MD5String(aValue));
  size:= Length(mystr) + 1;
  // return the size of the result
  Result:= size;
end;



exports
  MakeMD5Hash_Alex, MakeMD5Hash_L505, GetMD5HashSize_L505;

end.
